unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, CheckLst, Buttons;

type
  TForm1 = class(TForm)
    wordcountlabel: TLabel;
    Memo1: TMemo;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    gamecountlabel: TLabel;
    PaintBox1: TPaintBox;
    msglabel: TLabel;
    pauseBtn: TCheckBox;
    ListBox1: TListBox;
    stopBtn: TBitBtn;
    GObtn: TBitBtn;
    gameNrlabel: TLabel;
    Label5: TLabel;
    timelabel: TLabel;
    Timer1: TTimer;
    continueBtn: TSpeedButton;
    reportBtn: TCheckBox;
    Label1: TLabel;
    procedure GoBtnClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ListBox1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure stopBtnClick(Sender: TObject);
    procedure continueBtnClick(Sender: TObject);
    procedure continueBtnMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure continueBtnMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Timer1Timer(Sender: TObject);
    procedure PaintBox1Paint(Sender: TObject);
    procedure ListBox1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

var bitcount : byte; //game size
    numbers : array[1..518] of word;
    VNlist : array[0..16383] of boolean;//valid number list
    wcount : word;//number of valid words
    gameCount : int64;
    Acounter : array[1..14] of word;
    Amask : array[1..14] of word;
    AFixed : array[1..14] of word;
    VGame : array[1..14] of word;
    ExitFlag : boolean;
    PauzeFlag : boolean;
    t1 : dword;
    reportedGame : array[1..14] of word;
    rowsum : dword;
    Arowsums : array[0..14] of dword;
    bitcountmask : word;

procedure clearbox(pbox : Tpaintbox);
begin
 with pbox do with canvas do
  begin
   brush.Style := bsSolid;
   brush.color := $ffffff;
   fillrect(rect(0,0,width,height));
  end;
end;

function GetCellRect(i,j : byte) : Trect;
begin
 with result do
  begin
   left := (i-1)*25+81;
   top :=  (j-1)*25+1;
   right := left+24;
   bottom := top + 24;
  end;
end;

procedure paintgame;
var i,j : byte;
    w : word;
    r : Trect;
    ch : char;
    s,s1 : string;
begin
 if reportedGame[1] = 0 then exit;//no game
//
 with form1.PaintBox1.Canvas do
  for j := 1 to bitcount do
   begin
    w := numbers[reportedGame[j]];
    for i := 0 to bitcount-1 do
     begin
      r := GetCellRect(bitcount-i,j);
      brush.Style := bsSolid;
      if (AMask[j] and (1 shl i)) > 0 then brush.Color := $c0c0c0
       else brush.Color := $ffffff;
      fillrect(r);
      if (w and (1 shl i)) > 0 then ch := '1'else ch := '0';
      brush.Style := bsClear;
      textout(r.Left+7,r.Top+4,ch);
     end;
    s := inttostr(reportedGame[j]);
    s1 := '';
    brush.style := bsSolid;
    for i := 1 to 6-length(s) do s1 := s1 + ' ';
    textout(2,r.Top+4,s1+s);
   end;//for j
end;

procedure reporttime;
var t2 : dword;
    s : string;
begin
 t2 := gettickcount;
 s := formatfloat('##0.###',(t2-t1)*0.001);
 form1.timelabel.Caption := s;
end;

procedure reportGame;
var i : byte;
begin
 for i := 1 to bitcount do reportedgame[i] := Acounter[i];
 paintgame;
 form1.GameNrLabel.caption := inttostr(gamecount shr 1);
 form1.gamecountlabel.Caption := inttostr(gamecount);
 reporttime;
 application.ProcessMessages;
 if form1.pauseBtn.checked then
  begin
   pauzeflag := true;
   form1.msglabel.caption := 'pauze';
   while PauzeFlag do application.processmessages;
  end;
 form1.msglabel.caption := '';
end;

procedure reportword(w  : word);
//add word w to memo1
var i : byte;
    s : string;
begin
 s := '';
 for i := bitcount-1 downto 0 do
  if ((1 shl i) and w) > 0 then s :=s + '1' else s := s + '0';
 form1.memo1.lines.add(s);
end;

procedure clearAll;
var i : byte;
begin
 form1.paintbox1.invalidate;
 form1.memo1.clear;
 form1.gameNrlabel.Caption := '';
 gamecount := 0;
 form1.gamecountlabel.Caption := '';
 form1.msglabel.Caption := '';
 Arowsums[0] := 0;
 for i := 1 to 14 do
  begin
   Acounter[i] := 0;
   Amask[i] := 0;
   Afixed[i] := 0;
   reportedGame[i] := 0;
   Arowsums[i] := 0;
  end;
 application.ProcessMessages;
end;

function testValid(w : word) : boolean;
//called when generating numbers[ ]  array
//equal 0's 1's  <= 2 0's  1's in row
var total0 : byte;
    total1 : byte;
    s0 : byte;
    s1 : byte;
    m : word;
    i : byte;
    fixbits : byte;
begin
 result := true;
 fixbits := bitcount shr 1;
 m := 1;
 total0 := 0;
 total1 := 0;
 s0 := 0;
 s1 := 0;
 i := 0;
 while result and (i < bitcount) do
  begin
   if w and m > 0 then
    begin
     inc(total1);
     inc(s1);
     s0 := 0;
    end else begin
              inc(total0);
              inc(s0);
              s1 := 0;
             end;
   m := m shl 1;
   inc(i);
   result := (s0 <=2) and (s1 <= 2);
  end;
 result := result and (total0 = fixBits) and (total1 = fixBits);
end;

procedure MakeNumbers;
//sets vcount (valid number count)
//make index list
var n : word;
begin
 for n := 0 to 16383 do VNlist[n] := false;
 wcount := 0;
 for n := 0 to (1 shl bitcount)-1 do
  if testValid(n) then
   begin
    inc(wcount);
    numbers[wcount] := n;
    VNlist[n] := true;
   end;
 bitcountmask := (1 shl bitcount) - 1;
 rowsum := (bitcount shr 1)*bitcountmask;
end;

procedure makeFixedbits(ai : byte);
var N1,N2,X : word;
begin
 N1 := numbers[Acounter[ai-1]];
 N2 := numbers[Acounter[ai-2]];
 X := N1 xor N2;
 Amask[ai] := x xor bitcountmask;
 AFixed[ai] := N1 xor bitcountmask;
end;

function UsedWord(a : byte; wix : word) : boolean;
//exit true if wix (number index) used in Acounter 1..a-1
var i : byte;
begin
 i := 1;
 result := false;
 while (i < a) and (result = false) do
  begin
   result := Acounter[i] = wix;
   inc(i);
  end;
end;

procedure setGame1;
//set 1st game
var i : byte;
    n : word;
    OK : boolean;
begin
 Acounter[1] := 1;
 Acounter[2] := 2;
 i := 2;
 repeat
  inc(i);
  n := 2;
  repeat
   inc(n);
   if n > wcount then n := 3;
   OK := UsedWord(i,n)=false;
   if OK then
    begin
     makefixedbits(i);
     OK := ((numbers[n] xor AFixed[i]) and Amask[i]) = 0;
    end;
   if OK then Acounter[i] := n;
  until OK;
 until i = bitcount;
 for i := 1 to bitcount do ARowSums[i] := ARowSums[i-1] + numbers[Acounter[i]];
end;

function NextAcount : boolean;
//update Acounter array
//return false if end reached
var a : byte;  //index of Acounter
    n : word;  //Acounter value (index to number array)
label Linc;
begin
 a := bitcount;
 n := Acounter[a];

Linc:

 inc(n);
 if n > wcount then
  begin
   dec(a);
   n := Acounter[a];
   if a=1 then
    if n = wcount shr 1 then begin
                              result := false;
                              exit;
                             end;
   goto Linc;
  end;
 if ((numbers[n] xor Afixed[a]) and Amask[a]) <> 0 then goto Linc;
 if UsedWord(a,n) then goto Linc;
 Acounter[a] := n;
 ARowSums[a] := ARowSums[a-1] + numbers[n];
 if a < bitcount then
  begin
   inc(a);
   if a > 2 then makefixedbits(a);
   n := 0;
   goto Linc;
  end;
 result := true;
end;

procedure makeVGame;
var i,j : byte;
    m1,m2,w : word;
begin
 for i := 1 to bitcount do VGame[i] := 0;
 m1 := 1;  //mask
 for j := 1 to bitcount do         //step game rows
  begin
   w := numbers[Acounter[j]];      //data
   m2 := 1;
   for i := 1 to bitcount do       //step columns
    begin
     if (w and m2) <> 0 then VGame[i] := Vgame[i] or m1;
     m2 := m2 shl 1;
    end;
   m1 := m1 shl 1;
  end;
end;

function checkVGame : boolean;
var i,j : byte;
begin
 i := 0;
 repeat
  inc(i);
  result := VNlist[Vgame[i]];
 until (result=false) or (i = bitcount);
 if result then
  begin
   i := 0;
   repeat
    inc(i);
    j := i;
    repeat
     inc(j);
     result := Vgame[i] <> VGame[j];
    until (result=false) or (j=bitcount);
   until (result=false) or (i=bitcount-1);
  end;
end;

procedure TForm1.GoBtnClick(Sender: TObject);
var n : word;
    toc : dword;  //time out counter
begin
 clearAll;
 Makenumbers;
 setGame1;
 ExitFlag := false;
 toc := 0;
 for n := 1 to wcount do reportword(numbers[n]);//in memo
 wordcountlabel.Caption := inttostr(wcount);
 application.ProcessMessages;
 t1 := gettickcount;
 repeat
  inc(toc);
  if rowsum = ARowSums[bitcount] then
   begin
    makeVGame;
    if checkVGame then
     begin
      inc(gameCount,2); 
      if reportBtn.checked then reportgame;
     end;
   end;
  if toc = 1000000 then
   begin
    toc := 0;
    reporttime;
    gamecountlabel.Caption := inttostr(gamecount);
    if reportBtn.Checked then reportgame;
    application.ProcessMessages;
   end;
 until Exitflag or (NextAcount = false);
 gamecountlabel.Caption := inttostr(gamecount);
 if exitflag then msglabel.Caption := 'aborted'
  else begin
        msglabel.Caption := 'finished';
        reporttime;
       end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
 bitcount := 4;
 listbox1.ItemIndex := 0;
end;

procedure TForm1.ListBox1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 with listbox1 do
  begin
   bitcount := itemIndex*2 + 4;
  end;
 paintbox1.Invalidate; 
end;

procedure TForm1.stopBtnClick(Sender: TObject);
begin
 exitflag := true;
 PauzeFlag := false;
end;

procedure TForm1.continueBtnClick(Sender: TObject);
begin
 Pauzeflag := false;
end;

procedure TForm1.continueBtnMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
 pauzeflag := false;
 timer1.enabled := true;
end;

procedure TForm1.continueBtnMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 timer1.Enabled := false;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
 pauzeflag := false;
end;

procedure TForm1.PaintBox1Paint(Sender: TObject);
var i25,w : word;
    i : byte;
begin
 with PaintBox1 do with canvas do
  begin
   brush.color := $ffffff;
   brush.Style := bsSolid;
   fillrect(rect(0,0,width,height));
   pen.Width := 1;
   pen.Color := $0;
   w := 25*bitcount;
   for i := 0 to bitcount do
    begin
     i25 := i*25;
     moveto(80,i25);
     lineto(80+w,i25);
     moveto(80+i25,0);
     lineto(80+i25,w);
    end;
  end;
 paintgame;
end;

procedure TForm1.ListBox1Click(Sender: TObject);
begin
 paintbox1.Invalidate;
end;

end.
